Loading...
Searching...
No Matches
Scheduler Implementation API
Scheduler Event Generator

Scheduler Implementation API. More...

## Enumerations

enum | globus_scheduler_event_generator_error_t { GLOBUS_SEG_ERROR_TYPE_NULL = 1024 , GLOBUS_SEG_ERROR_TYPE_ALREADY_SET , GLOBUS_SEG_ERROR_TYPE_INVALID_MODULE , GLOBUS_SEG_ERROR_TYPE_INVALID_FORMAT , GLOBUS_SEG_ERROR_TYPE_OUT_OF_MEMORY , GLOBUS_SEG_ERROR_TYPE_LOADING_MODULE }

## Functions

globus_result_t | globus_scheduler_event (const char *format,...)
globus_result_t | globus_scheduler_event_pending (time_t timestamp, const char *jobid)
globus_result_t | globus_scheduler_event_active (time_t timestamp, const char *jobid)
globus_result_t | globus_scheduler_event_failed (time_t timestamp, const char *jobid, int failure_code)
globus_result_t | globus_scheduler_event_done (time_t timestamp, const char *jobid, int exit_code)
globus_result_t | globus_scheduler_event_generator_get_timestamp (time_t *timestamp)

## Detailed Description

Scheduler Implementation API.

Scheduler-specific SEG module implementations use this API to issue events to the Job State Monitor. Events occur whenever a job is placed in the scheduler's queue (PENDING), begins execution (ACTIVE), terminates successfully (DONE), or ends abnormally (FAILED).

A SEG module should register an event with the Globus event driver (most likely using either the Globus Callback or Globus XIO interfaces) in its activation function and then return. All events should be triggered from callbacks. When the SEG detects that it should terminate, it will deactivate the SEG module it started. The SEG module should wait for any outstanding callbacks to subside and before returning from its deactivation function to ensure that all events will be properly dispatched. After deactivation is complete, the SEG will unload the shared module and terminate.

## Enumeration Type Documentation

## globus_scheduler_event_generator_error_t

enum globus_scheduler_event_generator_error_t

Error types used by the SEG.

Enumerator
GLOBUS_SEG_ERROR_TYPE_NULL | NULL Parameter
GLOBUS_SEG_ERROR_TYPE_ALREADY_SET | Already called a one-time function
GLOBUS_SEG_ERROR_TYPE_INVALID_MODULE | Shared module missing descriptor
GLOBUS_SEG_ERROR_TYPE_INVALID_FORMAT | Invalid printf format for SEG protocol message
GLOBUS_SEG_ERROR_TYPE_OUT_OF_MEMORY | Out of memory
GLOBUS_SEG_ERROR_TYPE_LOADING_MODULE | Unable to load scheduler module

## Function Documentation

## globus_scheduler_event()

globus_result_t globus_scheduler_event | ( | const char * | format,
|  |  | ... )

Send an arbitrary SEG notification.

Parameters

  format | Printf-style format of the SEG notification message
  ... | Varargs which will be interpreted as per format.

Return values

  GLOBUS_SUCCESS | Scheduler message sent or queued.
  GLOBUS_SEG_ERROR_NULL | Null format.
  GLOBUS_SEG_ERROR_INVALID_FORMAT | Unable to determine length of formatted string.

## globus_scheduler_event_active()

globus_result_t globus_scheduler_event_active | ( | time_t | timestamp,
|  | const char * | jobid )

Send a job active event to the JobSchedulerMonitor implementation.

Parameters

  timestamp | Timestamp to use for the event. If set to 0, the time which this function was called is used.
  jobid | String indicating the scheduler-specific name of the job.

Return values

  GLOBUS_SUCCESS | Scheduler message sent or queued.
  GLOBUS_SEG_ERROR_NULL | Null jobid.
  GLOBUS_SEG_ERROR_INVALID_FORMAT | Unable to determine length of formatted string.

## globus_scheduler_event_done()

globus_result_t globus_scheduler_event_done | ( | time_t | timestamp,
|  | const char * | jobid,
|  | int | exit_code )

Send a job done event to the JobSchedulerMonitor implementation.

Parameters

  timestamp | Timestamp to use for the event. If set to 0, the time which this function was called is used.
  jobid | String indicating the scheduler-specific name of the job.
  exit_code | Exit code of the process if known.

Return values

  GLOBUS_SUCCESS | Scheduler message sent or queued.
  GLOBUS_SEG_ERROR_NULL | Null jobid.
  GLOBUS_SEG_ERROR_INVALID_FORMAT | Unable to determine length of formatted string.

## globus_scheduler_event_failed()

globus_result_t globus_scheduler_event_failed | ( | time_t | timestamp,
|  | const char * | jobid,
|  | int | failure_code )

Send a job failed event to the JobSchedulerMonitor implementation.

Parameters

  timestamp | Timestamp to use for the event. If set to 0, the time which this function was called is used.
  jobid | String indicating the scheduler-specific name of the job.
  failure_code | Failure code of the process if known.

Return values

  GLOBUS_SUCCESS | Scheduler message sent or queued.
  GLOBUS_SEG_ERROR_NULL | Null jobid.
  GLOBUS_SEG_ERROR_INVALID_FORMAT | Unable to determine length of formatted string.

## globus_scheduler_event_generator_get_timestamp()

globus_result_t globus_scheduler_event_generator_get_timestamp | ( | time_t * | timestamp | ) |

Get the timestamp for the earliest event an SEG module should send.

Parameters

  timestamp | Pointer to a time_t which will be set to the timestamp passed to the SEG executable. The module should not send any events which occur prior to this timestamp.

Return values

  GLOBUS_SEG_ERROR_NULL | Null timestamp.
  GLOBUS_SUCCESS | Timestamp value updated. If the timestamp was not set on the SEG command-line, then the value pointed to by timestamp will be set to 0.

## globus_scheduler_event_pending()

globus_result_t globus_scheduler_event_pending | ( | time_t | timestamp,
|  | const char * | jobid )

Send a job pending event to the JobSchedulerMonitor implementation.

Parameters

  timestamp | Timestamp to use for the event. If set to 0, the time which this function was called is used.
  jobid | String indicating the scheduler-specific name of the job.

Return values

  GLOBUS_SUCCESS | Scheduler message sent or queued.
  GLOBUS_SEG_ERROR_NULL | Null jobid.
  GLOBUS_SEG_ERROR_INVALID_FORMAT | Unable to determine length of formatted string.